freeslot(
	"SPR2_HAMR",
	"S_PLAY_HAMMERSPIN"
)

states[S_PLAY_HAMMERSPIN] = {SPR_PLAY, SPR2_HAMR, 1, nil, 0, 0, S_PLAY_HAMMERSPIN}

spr2defaults[SPR2_HAMR] = SPR2_TWIN

local function SaturnIslandAmy(player)
    if player.mo.skin ~= "amy" then
        return
    end

    if P_IsObjectOnGround(player.mo)
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
		and(player.hasdonehammerspin == true)
		and (player.cmd.buttons & BT_JUMP)
			player.mo.state = S_PLAY_SPRING
			player.hasdonehammerspin = false
			player.mo.momz = -player.previousfallspeed
			P_SetObjectMomZ(player.mo, 5*FRACUNIT, true)
			S_StartSound(player.mo, sfx_s1ab)
		end
		player.charflags = $ & ~SF_CANBUSTWALLS
		player.hasdonehammerspin = false
    end
	
	player.previousfallspeed = player.mo.momz
	
end

addHook("PlayerThink", SaturnIslandAmy)

local function HammerSpinAbility(player)
	if player.mo.skin ~= "amy" then
		return
	end
	
	if not (player.pflags & PF_THOKKED) then
		player.hasdonehammerspin = true
		player.pflags = $1|PF_THOKKED
		player.mo.state = S_PLAY_HAMMERSPIN
		player.pflags = $1|PF_SPINNING
		player.charflags = $1|SF_CANBUSTWALLS
		S_StartSound(player.mo, sfx_s3k42)
		return true
	end

	 -- Override default behavior
end

addHook("AbilitySpecial", HammerSpinAbility)

local function NewAmyCollision(player, object)
	if player.skin ~= "amy" then
		return
	end
	
	print("collision")
	return true
end

addHook("MobjCollide", function(spike, amy)
    if not (amy.player and amy.skin == "amy" and amy.state == S_PLAY_HAMMERSPIN)
        return nil
	end
    if (amy.z > spike.z+spike.height)
    or (spike.z > amy.z+amy.height)
        return nil
    else
        spike.health = 0
        S_StartSound(amy, spike.info.deathsound)
        P_KillMobj(spike, amy, amy)
        return false
    end
end, MT_SPIKE)

addHook("MobjMoveCollide", function(amy, spring)
	if not (amy.player and amy.skin == "amy")
		return nil
	end
	if not (spring.flags & MF_SPRING) return end
	if (amy.z > spring.z+spring.height+10*FRACUNIT)
	or (spring.z > amy.z+amy.height)
		return nil
	elseif (amy.player.mo.state == S_PLAY_HAMMERSPIN)
		S_StartSound(amy, sfx_sprong)
		P_DoSpring(spring, amy)
		if (spring.type ~= MT_YELLOWHORIZ and spring.type ~= MT_REDHORIZ and spring.type ~= MT_BLUEHORIZ)
			amy.player.mo.momz = $ * 5/4
			amy.state = S_PLAY_SPRING
		else
			amy.player.mo.momx = $ * 5/4
			amy.player.mo.momy = $ * 5/4
			amy.player.mo.state = S_PLAY_ROLL
			amy.player.pflags = $1|PF_SPINNING
		end
	end
end, MT_PLAYER)